<?php
$baseUrl = 'http://bridgetekcats.com/club_heymarket/';

$content = isset($_GET) ? implode(',',$_GET) : 'Not found';
//mail('suman.brainium@gmail.com','Response1 from clubready.', print_r($content, true));

$data = json_decode($content);
$ApiKey = $data->ApiKey;
$StoreId = $data->StoreId;
$email = $data->Email;
$full_name = $data->Name;
$name = split_name($full_name);
$first_name = $name['first_name'];
$middle_name = $name['middle_name'];
$last_name = $name['last_name'];
$baseUrl = $data->base_url;
$to = $data->Contact;
$send_sms_hook = $data->intro_class_hook;
$assign_class_hook = $data->assign_class_hook;



if($content!= '' && $ApiKey!='' && $StoreId!='' && $email!='' && $full_name!='' ){
	
	$contact = $data->Contact;	
	$LeadType = $data->LeadType;
	$LeadSource = $data->LeadSource;
	$ReferralTypeId = $data->ReferralTypeId;
	


	//service url
	$service_url = "https://www.clubready.com/api/current/users/prospect";
	$curl = curl_init();
	$curl_post_data = array(
		'ApiKey' => $ApiKey,
		'StoreId' => $StoreId,
		'FirstName' => $first_name.' '.$middle_name,
		'LastName' => $last_name,
		'Email' => $email,
		'Phone' => $contact,
		'LeadType' => $LeadType,
		'LeadSource' => $LeadSource,
		'ReferralTypeId' => $ReferralTypeId,
		'SendEmail'=> true
	);
	curl_setopt($curl,CURLOPT_URL,$service_url);
	curl_setopt($curl,CURLOPT_HEADER, false);
	curl_setopt($curl, CURLOPT_POST, true);
	curl_setopt($curl, CURLOPT_POSTFIELDS, $curl_post_data);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	$curl_response = curl_exec($curl);

	if ($curl_response === false) {
	    $info = curl_getinfo($curl);
	    die('error occured during curl exec. Additioanl info: ' . var_export($info));
	}
	//curl close
	curl_close($curl);
	//decode response
	$decoded = json_decode($curl_response, true);

	//check response status
	if (isset($decoded->Success) && $decoded->Success == 0) {
		if($decoded->Success == 0){
			$msg = 'Failure'; 
		}
	    die('error occured: ' . $msg);
	}
	
	$userID = $decoded['UserId'];
	
	//response_log('response.txt', print_r($decoded,true));
	if(!empty($userID))
	{
    	/*
    	* Store the USER Details in to google sheet by zap webhook
    	*/
    	$APIKEY = $ApiKey;
        $storeID = $StoreId;
    	$service_url = "https://www.clubready.com/api/current/users/".$userID.'?';
    	$curl = curl_init();
    	$curl_post_data = array(
    		'ApiKey' => $APIKEY,
    		'StoreId' => $storeID,
    		'FullDetail' => true,
    		'UserId' => $userID,
    	);
    	foreach($curl_post_data as $key=>$val)
    	{
    		$service_url .= $key.'='.$val.'&';
    	}
    	//echo $service_url;
    	$curl = curl_init();
    	curl_setopt($curl,CURLOPT_URL,$service_url);
    	curl_setopt($curl,CURLOPT_HEADER, false);
    	curl_setopt($curl, CURLOPT_HTTPGET, 1);
    	curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    	$curl_response = curl_exec($curl);
    	curl_close($curl);
    	$decoded = json_decode($curl_response, true);
    	
        
        $webHookURL = 'https://hooks.zapier.com/hooks/catch/2239486/fxvp8p/';
        $res = curl_init();
        curl_setopt( $res, CURLOPT_URL, $webHookURL );
        curl_setopt($res, CURLOPT_HTTPHEADER, array('Accept: application/json','Content-Type: application/json' ));
        curl_setopt( $res, CURLOPT_POSTFIELDS, json_encode($decoded) );
        curl_setopt( $res, CURLOPT_RETURNTRANSFER, true );
        $result = curl_exec( $res );
        /* End of the zap */
        
    	$classes = get_classes($ApiKey,$StoreId);
    //	response_log('response.txt', print_r($classes,true));
    	
    //	response_log('response.txt', print_r('================== User create =================',true));
    //	response_log('response.txt', print_r($userID,true));
    	
    	if(!empty($classes))
    	{
    	    $url = $baseUrl.'/my_class.php?apikey='.base64_encode($ApiKey).'&storeid='.base64_encode($StoreId).'&userid='.base64_encode($userID).'&base='.base64_encode($baseUrl).'&assign_class_hook='.base64_encode($assign_class_hook);
    	    $shortLink = create_short_url($url);
    	    
    	    
    	}
    	else
    	{
    	    $shortLink = '';
    	}
    //	response_log('response.txt', print_r('================== Stort link for '.$storeID.'=================',true));
    //	response_log('response.txt', print_r($shortLink,true));
    	$smsdata = send_sms($to, $email,$first_name,$middle_name,$last_name,$shortLink,$userID,$send_sms_hook);
    //	response_log('response.txt', print_r('================== SMS Send=================',true));
    	$cdata = json_encode($classes);
	}
   
}else{
	$missing_data = "Some data is missing.";
//	response_log('response.txt', $missing_data);
}	


/**
 * Log generate file
 */
function response_log($filename, $msg){  
   $fd = fopen($filename, "a"); 
   $str = "[" . date("Y/m/d h:i:s", time()) . "] " . $msg;  
   fwrite($fd, $str . "\n"); 
   fclose($fd); 
}

/**
 * Split name
 */
function split_name($string) {
	//array
    $arr = explode(' ', $string);
    $num = count($arr);
    if ($num == 2) {
        list($first_name, $last_name) = $arr;
    } else {
        list($first_name, $middle_name, $last_name) = $arr;
    }
    return (empty($first_name) || $num > 3) ? false : array(
        'first_name' => $first_name,
        'middle_name' => $middle_name,
        'last_name' => $last_name,
    );
}

/*
* Get all calsses
*/
function get_classes($ApiKey=0,$StoreId=0)
{
	$service_url = "https://www.clubready.com/api/current/scheduling/class-schedule?";
	$curl = curl_init();

	//curl post data
	$curl_post_data = array(
		'ApiKey' => $ApiKey,
		'StoreId' => $StoreId,
		'ToDate' => date('Y-m-d',strtotime("+7 day"))
	);
	foreach($curl_post_data as $key=>$val)
	{
		$service_url .= $key.'='.$val.'&';
	}
	
	curl_setopt($curl,CURLOPT_URL,$service_url);
	curl_setopt($curl,CURLOPT_HEADER, false);
	curl_setopt($curl, CURLOPT_HTTPGET, 1);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	$curl_response = curl_exec($curl);
	curl_close($curl);
	$decoded = json_decode($curl_response, true);
	$class = array();
	if(!empty($decoded))
	{
		foreach($decoded as $key=>$val)
		{
			if($val['Title'] == 'Demo' || $val['Title'] == 'Intro')
			{
				$class[] = $val;
			}
		}
	}
	return $class;
}

function send_sms( $to, $email,$first_name,$middle_name,$last_name,$shortLink,$userID,$send_sms_hook ) {
   
    $curl_post_data = array(
		'Phone' => $to,
		'Email' => $email,
		'FirstName' => $first_name,
		'MiddleName'=>$middle_name,
		'LastName'=>$last_name,
		'user_id'=>$userID,
		'short_link'=>$shortLink
	);
    // start cURL
    $webHookURL = !empty($send_sms_hook) ? $send_sms_hook : 'https://hooks.zapier.com/hooks/catch/2239486/eaxatg/';
    $res = curl_init();
    curl_setopt( $res, CURLOPT_URL, $webHookURL );
    curl_setopt($res, CURLOPT_HTTPHEADER, array('Accept: application/json','Content-Type: application/json' ));
    curl_setopt( $res, CURLOPT_POSTFIELDS, json_encode($curl_post_data) );
    curl_setopt( $res, CURLOPT_RETURNTRANSFER, true );
    $result = curl_exec( $res );
	curl_close($res);
    return $result;
}


function get_bitly_short_url($url,$login,$appkey,$format='txt') {
	$connectURL = 'http://api.bit.ly/v3/shorten?login='.$login.'&apiKey='.$appkey.'&uri='.urlencode($url).'&format='.$format;
	return curl_get_result($connectURL);
}


/* returns a result form url */
function curl_get_result($url) {
	$ch = curl_init();
	$timeout = 5;
	curl_setopt($ch,CURLOPT_URL,$url);
	curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
	curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout);
	$data = curl_exec($ch);
	curl_close($ch);
	return $data;
}

function create_short_url($url)
{
	/*$fields = array('longUrl'=>$url);
	$data_string = '{ "longUrl": "'.$url.'" }';
	$curl = curl_init();
	curl_setopt( $curl, CURLOPT_URL, 'https://www.googleapis.com/urlshortener/v1/url?key=AIzaSyAIfkKBd08LOb4zlH-ATdKtkFccX3vRXdg' );
	curl_setopt( $curl, CURLOPT_RETURNTRANSFER, true ); // don't echo
	curl_setopt($curl, CURLOPT_POST, 1);
    curl_setopt( $curl, CURLOPT_POSTFIELDS, $data_string );
    curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: application/json' ));
    
	$curl_response = curl_exec($curl);
	curl_close($curl);
	$decoded = json_decode($curl_response, true);
	if(!empty($decoded))
	{
	    response_log('response.txt', print_r($decoded['id'],true));
	    response_log('response.txt', print_r($url,true));
		return $decoded['id'];
	}
	else{
		return $url;
	}
	*/
	$login = 'sumanbrainium';
	$appkey = 'R_c00f828f7c734e27ba6ab2cd91386949';
	$format = 'txt';
	$connectURL = 'http://api.bit.ly/v3/shorten?login='.$login.'&apiKey='.$appkey.'&uri='.urlencode($url).'&format='.$format;
	
	$ch = curl_init();
	$timeout = 5;
	curl_setopt($ch,CURLOPT_URL,$connectURL);
	curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);
	curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout);
	$data = curl_exec($ch);
	curl_close($ch);
	return $data;
}
?>