<?php
ini_set('max_execution_time', 5000);
$content = isset($_POST) ? implode(',',$_GET) : 'Not found';

$ApiKey = $_POST['ApiKey'];
$StoreId = $_POST['StoreId'];
error_log("API KEY :".$_POST['ApiKey']);
error_log("Date : ".date('Y-m-d'));
//$ApiKey = 'd1762892-0fdd-45a5-88a1-b31dc8eb24cb';
//$StoreId = 3510;
/*
* Database Details
*/
$dbName = 'logincat_club_ready';
$dbUser = 'logincat_brainiu';
$dbPassword = 'buFFiqbjN677';
$dbTablename = 'club_user';

$con = mysqli_connect('localhost', $dbUser, $dbPassword, $dbName);


if(isset($_POST['ApiKey']) && isset($_POST['StoreId'])){
	$body =  'Here is the member list for ('.$StoreId.')';
	$to = 'bridgetek@gmail.com,suman.brainium@gmail.com';
	$subject = 'New Member list for ( '.$StoreId.' )';
	$from = 'tony@bridgetekcommunications.com';
	send_csv_mail($body, $to, $subject, $from);
   
}else{
	$missing_data = "Some data is missing.";
}	

function get_club_user_details($userID)
{
	global $ApiKey,$StoreId;
	$service_url = "https://www.clubready.com/api/current/users/".$userID."?";
	$curl = curl_init();
	$curl_post_data = array(
		'ApiKey' => $ApiKey,
		'StoreId' => $StoreId,
		'UserId' => $userID,
		'FullDetail'=>true
	);
	foreach($curl_post_data as $key=>$val)
	{
		$service_url .= $key.'='.$val.'&';
	}
	
	curl_setopt($curl,CURLOPT_URL,$service_url);
	curl_setopt($curl,CURLOPT_HEADER, false);
	curl_setopt($curl, CURLOPT_HTTPGET, 1);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	$curl_response = curl_exec($curl);
	
	if ($curl_response === false) {
		$info = curl_getinfo($curl);
		error_log('error occured during curl exec. Additioanl info: ' . var_export($info));
	}
	curl_close($curl);
	$decoded = json_decode($curl_response, true);
	return $decoded;
}
function create_csv_string($data) {
    
    global $dbTablename,$con,$StoreId;
	$sql_statement = "select id,user_id,status,created_on from ".$dbTablename." where is_member=0 and store_id=".$StoreId." ORDER BY `club_user`.`id` ASC";
	$qry = mysqli_query($con,$sql_statement);
	$num_rows = mysqli_num_rows($qry);
    $count = 0;
    
    // Open temp file pointer
    if (!$fp = fopen('php://temp', 'w+')) return FALSE;
    
    fputcsv($fp, array('Store ID','User ID', 'First Name', 'Last Name','Email','Phone Cell','Phone Home','Last Payment Date','Last payment Amount','Member Since Date','Postal Code','Date of Birth'));
    
    // Loop data and write to file pointer
	//error_log("=============================================");
    while ($line = mysqli_fetch_assoc($qry))
	{
		$userId = $line['user_id'];
		$dbID = $line['id'];
		$getUserDetails = get_club_user_details($userId);
		
		//error_log("Data::".$getUserDetails['UserId']);
		if($getUserDetails)
		{
			$ismember = $getUserDetails['Member'];
			if($ismember)
			{
				$MemberSinceDate 	= $getUserDetails['MemberSinceDate'];
				$UserId 			= $getUserDetails['UserId'];
				$FirstName 			= $getUserDetails['FirstName'];
				$LastName 			= $getUserDetails['LastName'];
				$Email 				= $getUserDetails['Email'];
				$PhoneCell 			= $getUserDetails['PhoneCell'];
				$PhoneHome 			= $getUserDetails['PhoneHome'];
				$LastPayDate 		= $getUserDetails['LastPayDate'];
				$LastPaymentAmount 	= $getUserDetails['LastPaymentAmount'];
				$PostalCode			= $getUserDetails['PostalCode'];
				$DateOfBirth		= $getUserDetails['DateOfBirth'];
				$csvArray = array(
					$StoreId,
					$UserId,
					$FirstName,
					$LastName,
					$Email,
					$PhoneCell,
					$PhoneHome,
					$LastPayDate,
					$LastPaymentAmount,
					$MemberSinceDate,
					$PostalCode,
					$DateOfBirth
				);
				fputcsv($fp, $csvArray);
				update_user_in_database($dbID);
				$count++;
			}			
		}	
	}
    //error_log("=============================================");
    // Place stream pointer at beginning
    rewind($fp);
    // Return the data
	if($count)
	{
		return stream_get_contents($fp);
	}
	else{
		return 0;
	}
    
}

function send_csv_mail($body, $to, $subject, $from) {

    // This will provide plenty adequate entropy
    $multipartSep = '-----'.md5(time()).'-----';

    // Arrays are much more readable
    $headers = array(
        "From: Club Ready Member List<$from>",
        "Reply-To: $from",
        "Content-Type: multipart/mixed; boundary=".$multipartSep
    );

    // Make the attachment
	$csvFile = create_csv_string($csvData);
    $attachment = chunk_split(base64_encode($csvFile)); 

	if($csvFile)
	{
		// Make the body of the message
		$body = "--$multipartSep\r\n"
			. "Content-Type: text/plain; charset=ISO-8859-1; format=flowed\r\n"
			. "Content-Transfer-Encoding: 7bit\r\n"
			. "\r\n"
			. "$body\r\n"
			. "--$multipartSep\r\n"
			. "Content-Type: text/csv\r\n"
			. "Content-Transfer-Encoding: base64\r\n"
			. "Content-Disposition: attachment; filename=Club Ready Member Report-" . date("F-j-Y") . ".csv\r\n"
			. "\r\n"
			. "$attachment\r\n"
			. "--$multipartSep--";

		// Send the email, return the result
		error_log("Mail Send on::".date('Y-m-d'));
		return @mail($to, $subject, $body, implode("\r\n", $headers));
	}
}
function update_user_in_database($id=0)
{
	global $dbTablename,$con;
	$sql_statement = "update ".$dbTablename." set is_member=1 , updated_on='".date('Y-m-d')."' where id=".$id;
	$qry = mysqli_query($con,$sql_statement);
	return true;
}
?>